/**********************************************************************************************/
/* OpenSi : Logiciel SaaS de gestion commerciale et comptabilit spcialis dans l'e-commerce */
/* Copyright (c) - Tous droits rservs - SAS Speedinfo Evolution                             */
/**********************************************************************************************/

jsLoader.loadSubScript("chrome://opensi/content/libs/arbres.js");
jsLoader.loadSubScript("chrome://opensi/content/libs/query.js");
jsLoader.loadSubScript("chrome://opensi/content/libs/verif.js");

var aComptes;
var filtreNumero;
var filtreIntitule;
var filtreType;

function init() {
	try {
		document.getElementById('filtreNumero').focus();

		resetFiltres();
		filtreNumero = window.arguments[1];
		document.getElementById('filtreNumero').value = filtreNumero;

		aComptes = new Arbre("Compta/Analytique/Comptes/listeComptes.tmpl","treeComptes");
  		initArbreComptes();
	} catch (e) {
		recup_erreur(e);
	}
}

function resetFiltres() {
	try {
		// reset des variables globales
		filtreNumero = "";
		filtreIntitule = "";
		filtreType = 2;

		// reset des champs du document
		document.getElementById('filtreNumero').value = filtreNumero;
		document.getElementById('filtreIntitule').value = filtreIntitule;
		document.getElementById('filtreType').value = filtreType;

	} catch (e) {
		recup_erreur(e);
	}
}

function activeMenu(boolean) {
	try {
		// activation des filtres de recherche
		document.getElementById('filtreNumero').disabled = !boolean;
		document.getElementById('filtreIntitule').disabled = !boolean;
		document.getElementById('filtreType').disabled = !boolean;
		document.getElementById('bActualiser').disabled = !boolean;
		document.getElementById('bReinitialiser').disabled = !boolean;

		// activation de l'arbre
		document.getElementById('treeComptes').disabled = !boolean;

		// activation des actions
		document.getElementById('bAnnuler').disabled = !boolean;
		document.getElementById('bValider').disabled = !boolean;
	} catch (e) {
		recup_erreur(e);
	}
}

function finInit() {
	try {
  		activeMenu(true);
	} catch (e) {
		recup_erreur(e);
	}
}

function initArbreComptes() {
	try {
		aComptes.clearParams();
		if (!isEmpty(filtreNumero)) {
			aComptes.setParam("Numero", filtreNumero);
		}
		if (!isEmpty(filtreIntitule)) {
			aComptes.setParam("Intitule", filtreIntitule);
		}
		if (filtreType!=2) {
			aComptes.setParam("Direct", filtreType);
		}
		aComptes.setParam("Actif", 1);

		aComptes.initTree(finInit);
	} catch (e) {
		recup_erreur(e);
	}
}



function changeOnFiltreNumero() {
	try {
		filtreNumero = document.getElementById('filtreNumero').value;
	} catch (e) {
		recup_erreur(e);
	}
}

function changeOnFiltreIntitule() {
	try {
		filtreIntitule = document.getElementById('filtreIntitule').value;
	} catch (e) {
		recup_erreur(e);
	}
}

function keyPressOnFiltreNumero(event) {
	try {
		if (event.keyCode==13) {
			activeMenu(false);
			filtreNumero = document.getElementById('filtreNumero').value;
			initArbreComptes();
		}
	} catch (e) {
		recup_erreur(e);
	}
}

function keyPressOnFiltreIntitule(event) {
	try {
		if (event.keyCode==13) {
			activeMenu(false);
			filtreIntitule = document.getElementById('filtreIntitule').value;
			initArbreComptes();
		}
	} catch (e) {
		recup_erreur(e);
	}
}

function selectOnFiltreType() {
	try {
		activeMenu(false);
		filtreType = document.getElementById('filtreType').value;
		initArbreComptes();
	} catch (e) {
		recup_erreur(e);
	}
}

function pressOnActualiser() {
	try {
		activeMenu(false);
		initArbreComptes();
	} catch (e) {
		recup_erreur(e);
	}
}

function pressOnReinitialiser() {
	try {
		activeMenu(false);
		resetFiltres();
		initArbreComptes();
	} catch (e) {
		recup_erreur(e);
	}
}

function selectOnTreeComptes() {
	try {
 		if (aComptes.isSelected()) {
 			var index = aComptes.getCurrentIndex();

			filtreNumero = aComptes.getCellText(index,'colNumero');
			filtreIntitule = aComptes.getCellText(index,'colIntitule');
			filtreType = aComptes.getCellText(index,'colType');

			document.getElementById('filtreNumero').value = filtreNumero;
			document.getElementById('filtreIntitule').value = filtreIntitule;
			document.getElementById('filtreType').value = filtreType;
		}
	} catch (e) {
		recup_erreur(e);
	}
}

function dblClickOnTreeComptes() {
	try {
		if (aComptes.isSelected()) {
			activeMenu(false);
			valideCompte();
		}
	} catch (e) {
		recup_erreur(e);
	}
}

function pressOnAnnuler() {
	try {
		activeMenu(false);
		window.close();
	} catch (e) {
		recup_erreur(e);
	}
}

function pressOnOk() {
	try {
		activeMenu(false);
		valideCompte();
	} catch (e) {
		recup_erreur(e);
	}
}

function valideCompte() {
	try {
		if (isEmpty(filtreNumero)) {
			showWarning("Veuillez saisir un num\u00E9ro de compte !");
			activeMenu(true);
		} else {
			var qExistCompteByNumero = new QueryHttp("Compta/Analytique/Comptes/getCompteByNumero.tmpl");
			qExistCompteByNumero.setParam("Numero", filtreNumero);
			var result = qExistCompteByNumero.execute();
			var errors = new Errors(result);

			if (errors.hasNext()) {
				errors.show();
				initArbreComptes();
				activeMenu(true);
			} else {
				var actif = result.responseXML.documentElement.getAttribute('Actif')=="true";
				if (actif) {
					var id = result.responseXML.documentElement.getAttribute('Compte_Id');
					var numero = result.responseXML.documentElement.getAttribute('Numero');
					var libelle = result.responseXML.documentElement.getAttribute('Intitule');
					window.arguments[0](id, numero, libelle);
					window.close();
				} else {
					showWarning("Veuillez saisir un compte actif");
					activeMenu(true);
				}
			}
		}
	} catch (e) {
		recup_erreur(e);
	}
}
