/**********************************************************************************************/
/* OpenSi : Logiciel SaaS de gestion commerciale et comptabilit spcialis dans l'e-commerce */
/* Copyright (c) - Tous droits rservs - SAS Speedinfo Evolution                             */
/**********************************************************************************************/



var oc_aTranches = new Arbre("Compta/Config/collectifs/liste-tranchesCollectifs.tmpl", "oc-listeTranchesCollectifs");
var oc_currentTrancheId;


function oc_init() {
	try {
		oc_aTranches.initTree(oc_nouvelleTranche);
	} catch (e) {
		recup_erreur(e);
	}
}



function oc_selectTranche() {
	try {

		if (oc_aTranches.isSelected()) {
			var currentIndex = oc_aTranches.getCurrentIndex();

			document.getElementById('oc-compteDebut').value = oc_aTranches.getCellText(currentIndex, 'oc-colCompteDebut');
			document.getElementById('oc-compteFin').value = oc_aTranches.getCellText(currentIndex, 'oc-colCompteFin');
			oc_currentTrancheId = oc_aTranches.getCellText(currentIndex, 'oc-colTrancheId');

			document.getElementById('oc-bSupprimer').disabled = false;
		}

	} catch (e) {
		recup_erreur(e);
	}
}


function oc_nouvelleTranche() {
	try {

		if (oc_aTranches.isSelected()) {
			oc_aTranches.clearSelection();
		}
		oc_currentTrancheId = "";

		document.getElementById('oc-compteDebut').value = "";
		document.getElementById('oc-compteFin').value = "";

		document.getElementById('oc-bSupprimer').disabled = true;

	} catch (e) {
		recup_erreur(e);
	}
}



function oc_supprimerTranche() {
	try {

		if (oc_currentTrancheId!="") {
			var currentIndex = oc_aTranches.getCurrentIndex();
			var compteDebut = oc_aTranches.getCellText(currentIndex, 'oc-colCompteDebut');
			var compteFin = oc_aTranches.getCellText(currentIndex, 'oc-colCompteFin');

			if (window.confirm("Confirmez-vous la suppression de la tranche du compte '"+ compteDebut +"' \u00E0 '"+ compteFin +"' ?")) {

				var qSupprimerTranche = new QueryHttp("Compta/Config/collectifs/supprimerTrancheCollectifs.tmpl");
				qSupprimerTranche.setParam("Tranche_Id", oc_currentTrancheId);
				var result = qSupprimerTranche.execute();

				var errors = new Errors(result);

				if (errors.hasNext()) {
					errors.show();
				}
				else {
					oc_aTranches.initTree(oc_nouvelleTranche);
				}
			}
		}

	} catch (e) {
		recup_erreur(e);
	}
}




function oc_enregistrerTranche() {
	try {

		var compteDebut = document.getElementById('oc-compteDebut').value;
		var compteFin = document.getElementById('oc-compteFin').value;

		if (!isCompteCorrect(compteDebut)) { showWarning("Compte de d\u00E9but incorrect !"); }
		else if (!isCompteCorrect(compteFin)) { showWarning("Compte de fin incorrect !"); }
		else if (compteDebut>compteFin) { showWarning("Le compte de d\u00E9but doit \u00EAtre inf\u00E9rieur au compte de fin !"); }
		else {

			var qEnregistrerTranche = new QueryHttp("Compta/Config/collectifs/enregistrerTrancheCollectifs.tmpl");
			qEnregistrerTranche.setParam("Tranche_Id", oc_currentTrancheId!=""?oc_currentTrancheId:"0");
			qEnregistrerTranche.setParam("Compte_Debut", compteDebut);
			qEnregistrerTranche.setParam("Compte_Fin", compteFin);

			var result = qEnregistrerTranche.execute();
			var errors = new Errors(result);

			if (errors.hasNext()) {
				errors.show();
			}
			else {
				oc_aTranches.initTree(oc_nouvelleTranche);
			}
		}

	} catch (e) {
		recup_erreur(e);
	}
}

