/**********************************************************************************************/
/* OpenSi : Logiciel SaaS de gestion commerciale et comptabilit spcialis dans l'e-commerce */
/* Copyright (c) - Tous droits rservs - SAS Speedinfo Evolution                             */
/**********************************************************************************************/

var oli_aListeImport;

var oli_filtreEtat;
var oli_filtreJournal;
var oli_filtreDateModif;

var oli_nbPages;
var oli_pageCourante;


function oli_init() {
	try {

		var aFiltreJournaux = new Arbre('ComboListe/combo-journaux.tmpl', 'oli-filtreJournal');
		aFiltreJournaux.setParam("Type_Journal", "TR");
 		aFiltreJournaux.initTree();

		document.getElementById("oli-filtreEtat").selectedIndex = 0;
		oli_filtreEtat = document.getElementById('oli-filtreEtat').value;
		document.getElementById("oli-filtreJournal").selectedIndex = 0;
		oli_filtreJournal = document.getElementById('oli-filtreJournal').value;
		oli_filtreDateModif = document.getElementById('oli-filtreDateModif').value;

		// initialisation de la liste d'import
		oli_aListeImport = new Arbre('Compta/ImportBanque/listeImport.tmpl','oli-treeImport');
		oli_reset();

	} catch (e) {
  	recup_erreur(e);
	}
}

function oli_initListe() {
	try {
		var go = true;
		oli_aListeImport.clearParams();

		oli_aListeImport.setParam('etatImport', oli_filtreEtat);
		oli_aListeImport.setParam('journalImport', oli_filtreJournal);

		if (!isEmpty(oli_filtreDateModif)) {
			oli_aListeImport.setParam('dateModifImport', oli_filtreDateModif);
		}

  		oli_aListeImport.setParam('pageCourante', oli_pageCourante);
  		oli_aListeImport.setParam('nbLignesParPage', document.getElementById('oli-nbLignesParPage').value);

  		oli_aListeImport.initTree(oli_activeMenu());
	} catch (e) {
		recup_erreur(e);
	}
}

function oli_initNbPages() {
	try {
		oli_nbPages = 0;
		var go = true;

		var queryTotaux = new QueryHttp("Compta/ImportBanque/getTotauxListeImport.tmpl");

		queryTotaux.setParam('etatImport', oli_filtreEtat);
		queryTotaux.setParam('journalImport', oli_filtreJournal);
		if (!isEmpty(oli_filtreDateModif)) {
			queryTotaux.setParam('dateModifImport', oli_filtreDateModif);
		}

		queryTotaux.setParam('nbLignesParPage', document.getElementById('oli-nbLignesParPage').value);

		var result = queryTotaux.execute();
		oli_nbPages = result.responseXML.documentElement.getAttribute("nbPages");
	} catch (e) {
		recup_erreur(e);
	}
}

function oli_activeMenu() {
	try {
		document.getElementById('oli-filtreDateModif').disabled = false;
		document.getElementById('oli-filtreEtat').disabled = false;
		document.getElementById('oli-filtreJournal').disabled = false;
		document.getElementById('oli-nouvelImport').disabled = false;

		document.getElementById('oli-bPrec').disabled = !(oli_pageCourante>1);
		document.getElementById('oli-bSuiv').disabled = !(oli_pageCourante<oli_nbPages);
		document.getElementById('oli-pageDeb').value = oli_pageCourante;
		document.getElementById('oli-pageFin').value = (oli_nbPages==0)?"1":oli_nbPages;
	} catch (e) {
		recup_erreur(e);
	}
}

function oli_desactiveMenu() {
	try {
		document.getElementById('oli-filtreDateModif').disabled = true;
		document.getElementById('oli-filtreEtat').disabled = true;
		document.getElementById('oli-filtreJournal').disabled = true;
		document.getElementById('oli-nouvelImport').disabled = true;
		document.getElementById('oli-bPrec').disabled = true;
		document.getElementById('oli-bSuiv').disabled = true;
	} catch (e) {
		recup_erreur(e);
	}
}

function oli_reset() {
	try {
		var go = true;
		// rcupration des variables de filtre
		oli_filtreEtat = document.getElementById('oli-filtreEtat').value;
		oli_filtreJournal = document.getElementById('oli-filtreJournal').value;

		oli_filtreDateModif = document.getElementById('oli-filtreDateModif').value;
		if (!isEmpty(oli_filtreDateModif)) {
			if (!isDate(oli_filtreDateModif)) {
				showWarning("Date incorrecte !");
				go = false;
			} else {
				oli_filtreDateModif = prepareDateJava(oli_filtreDateModif);
			}
		}

		// rinitialistion
		if (go) {
			oli_desactiveMenu();
	  		oli_pageCourante = 1;
	  		oli_initNbPages();
	  		oli_initListe();
	  	}
	} catch (e) {
  		recup_erreur(e);
	}
}

function oli_keyPressOnDateModif(event) {
	try {
		if (event.keyCode==13) {
			oli_reset();
		}
	} catch (e) {
  		recup_erreur(e);
	}
}

function oli_selectOnFiltreJournal() {
	try {
		oli_reset();
	} catch (e) {
  		recup_erreur(e);
	}
}

function oli_selectOnFiltreEtat() {
	try {
		oli_reset();
	} catch (e) {
  		recup_erreur(e);
	}
}

function oli_pressOnNouveau() {
	try {
  		document.getElementById('bRetourListeImports').collapsed = false;
		changeDeck(1);
		oib_nouveau();
	} catch (e) {
		recup_erreur(e);
	}
}

function oli_pressOnPagePrec() {
	try {
  		oli_desactiveMenu();
  		oli_pageCourante--;
  		oli_initListe();
	} catch (e) {
		recup_erreur(e);
	}
}

function oli_pressOnPageSuiv() {
	try {
  		oli_desactiveMenu();
  		oli_pageCourante++;
  		oli_initListe();
	} catch (e) {
		recup_erreur(e);
	}
}

function oli_dblClickOnTreeImport() {
 	try {
 		if (oli_aListeImport.isSelected()) {
  			var index = oli_aListeImport.getCurrentIndex();
  			var id = oli_aListeImport.getCellText(index,'oli-colImportId');
  			document.getElementById('bRetourListeImports').collapsed = false;
  			changeDeck(1);
  			oib_ouvrir(id);
		}
 	} catch (e) {
 		recup_erreur(e);
 	}
 }
