/**********************************************************************************************/
/* OpenSi : Logiciel SaaS de gestion commerciale et comptabilit spcialis dans l'e-commerce */
/* Copyright (c) - Tous droits rservs - SAS Speedinfo Evolution                             */
/**********************************************************************************************/


jsLoader.loadSubScript("chrome://opensi/content/libs/arbres.js");
jsLoader.loadSubScript("chrome://opensi/content/libs/query.js");
jsLoader.loadSubScript("chrome://opensi/content/libs/verif.js");

var aComboModes;
var aListeModeles;
var aModeleEcriture;

var modeleId;
var ligneId;
var change;
var etat;

function init() {
	try {
		// init des variables globales
		modeleId = 0;
		ligneId = 0;
		change = false;
		etat = 'N';

		// init de la menulist des modes de rglement
  		aComboModes = new Arbre("ComboListe/combo-modesReglement.tmpl","filtreModesLigne");
  		aComboModes.initTree();

  		// init de la liste des modeles dispo
  		aListeModeles = new Arbre("Compta/Modele/listeModele.tmpl","treeModele");
  		aListeModeles.initTree();

  		// init des lignes du modle
  		aModeleEcriture = new Arbre("Compta/Modele/listeLigne.tmpl","treeLigne");
  		aModeleEcriture.initTree();

  		// prparation du menu
  		activeMenu();
	} catch (e) {
		recup_erreur(e);
	}
}

function retourMenuPrincipal() {
	try {

    window.location = "chrome://opensi/content/compta/user/menu_exercice.xul?"+ cookie();

	} catch (e) {
		recup_erreur(e);
	}
}

function selectOnTreeModele() {
	try {
 		if (aListeModeles.isSelected()) {
 			var index = aListeModeles.getCurrentIndex();
			var id = aListeModeles.getCellText(index,"colModeleId");
			ouvrir(id);
		}
	} catch (e) {
		recup_erreur(e);
	}
}

function ouvrir(id) {
	try {
		modeleId = id;

		// rcupration des infos du modle
		var qGetModele = new QueryHttp("Compta/Modele/getModele.tmpl");
		if (modeleId!=0) {
			qGetModele.setParam("IdModele", modeleId);
		}
		var result = qGetModele.execute();

		var libelle = result.responseXML.documentElement.getAttribute('libelle');
		var raccourci = result.responseXML.documentElement.getAttribute('raccourci');
		var codeEtat = result.responseXML.documentElement.getAttribute('etat');

		// affichage du modle
		document.getElementById('libelle').value = libelle;
		document.getElementById('raccourci').value = raccourci;

		// init var globales
		ligneId = 0;
		change = false;
		etat = codeEtat;

		// init des lignes du modle
		aModeleEcriture.clearParams();
		aModeleEcriture.setParam("ModId", modeleId);
		aModeleEcriture.initTree(finInitModele);

	} catch (e) {
		recup_erreur(e);
	}
}

function finInitModele() {
	try {
		// WARNING : problme de synchronisation !!!
		setTimeout("activeMenu();", 100);
	} catch (e) {
  		recup_erreur(e);
	}
}

function activeMenu() {
	try {
		// actions gnrales
		document.getElementById('bNouveau').disabled = false;
		document.getElementById('bEnregistrer').disabled = !change;
		document.getElementById('bSupprimer').disabled = (modeleId==0);
		document.getElementById('bCopier').disabled = (modeleId==0 || change);
		document.getElementById('bValider').disabled = (modeleId==0 || change || etat=='V');

		// champs de saisie de ligne
		document.getElementById('compteLigne').disabled = (modeleId==0);
		document.getElementById('libelleLigne').disabled = (modeleId==0);
		document.getElementById('filtreModesLigne').disabled = (modeleId==0);
		document.getElementById('infosLigne').disabled = (modeleId==0);
		document.getElementById('debitLigne').disabled = (modeleId==0);
		document.getElementById('creditLigne').disabled = (modeleId==0);
		document.getElementById('pieceLigne').disabled = (modeleId==0);
		document.getElementById('filtreCalculLigne').disabled = (modeleId==0);

		// actions sur les lignes
		document.getElementById('bAnnulerLigne').disabled = (modeleId==0);
		document.getElementById('bValiderLigne').disabled = (modeleId==0);
		document.getElementById('bSupprimerLigne').disabled = (modeleId==0);

		// reset ligne
		annulerLigneModele();
	} catch (e) {
  		recup_erreur(e);
	}
}

function desactiveMenu() {
	try {
		// actions gnrales
		document.getElementById('bNouveau').disabled = true;
		document.getElementById('bEnregistrer').disabled = true;
		document.getElementById('bSupprimer').disabled = true;
		document.getElementById('bCopier').disabled = true;
		document.getElementById('bValider').disabled = true;

		// actions sur les lignes
		document.getElementById('bAnnulerLigne').disabled = true;
		document.getElementById('bValiderLigne').disabled = true;
		document.getElementById('bSupprimerLigne').disabled = true;
	} catch (e) {
  		recup_erreur(e);
	}
}

function keyPressOnLibelle(event) {
	try {
		change = true;
		activeMenu();
	} catch (e) {
		recup_erreur(e);
	}
}

function changeOnRaccourci() {
	try {
		change = true;
		activeMenu();
	} catch (e) {
		recup_erreur(e);
	}
}

function pressOnNouveau() {
	try {
		var go = true;
		if (change) {
			go = window.confirm("Voulez-vous saisir un nouveau mod\u00E8le d'\u00E9criture ?\nVous allez perdre les informations non enregistr\u00E9es.");
		}
		if (go) {
			desactiveMenu();
			nouveau();
		}
	} catch (e) {
		recup_erreur(e);
	}
}

function pressOnSupprimer() {
	try {
		var go = false;
		if (modeleId!=0) {
			go = window.confirm("Voulez-vous supprimer ce mod\u00E8le ?");
		}
		if (go) {
			desactiveMenu();
			supprimer();
		}
	} catch (e) {
		recup_erreur(e);
	}
}

function pressOnEnregistrer() {
	try {
		var go = false;
		// verifs diverses
		// libelle unique -> vrifi sur le serveur
		// raccourci 0  9 : 0 selectionnable n fois, 1  9 une seule fois
		var raccourci = document.getElementById('raccourci').value;
		if (raccourci==0 || !existRaccourci(raccourci)) {
			go = true;
		} else { showWarning("Ce raccourci est d\u00E9j\u00E0 utilis\u00E9 !") }

		if (go) {
			desactiveMenu();
			enregistrer();
		}
	} catch (e) {
		recup_erreur(e);
	}
}

function existRaccourci(raccourci) {
	try {
		var trouve = false;
		var i=0;
		while (i<aListeModeles.nbLignes() && !trouve) {
			if (aListeModeles.getCellText(i,"colRaccourci")==raccourci) {
				trouve = true;
			}
			i++;
		}
		return trouve;
	} catch (e) {
		recup_erreur(e);
	}
}

function pressOnCopier() {
	try {
		var go = false;
		if (modeleId!=0) {
			go = window.confirm("Voulez-vous dupliquer ce mod\u00E8le ?")
		}
		if (go) {
			desactiveMenu();
			copier();
		}
	} catch (e) {
		recup_erreur(e);
	}
}

function pressOnValider() {
	try {
		var go = false;
		if (modeleId!=0) {
			go = window.confirm("Voulez-vous valider ce mod\u00E8le ?");
		}
		if (go) {
			desactiveMenu();
			valider();
		}
	} catch (e) {
		recup_erreur(e);
	}
}

function nouveau() {
	try {
		// deselection
		aListeModeles.clearSelection();

  		// reset des variables globales
  		modeleId = 0;
  		ligneId = 0;
  		change = false;

  		// reset de l'arbre
  		aModeleEcriture.deleteTree();

  		// reset du modle
  		document.getElementById('libelle').value = "";
  		document.getElementById('raccourci').value = 0;

  		// reset du formulaire de ligne
  		annulerLigneModele();

  		// refresh menu
  		activeMenu();
	} catch (e) {
		recup_erreur(e);
	}
}

function supprimer() {
	try {
		var queryDelete = new QueryHttp("Compta/Modele/deleteModele.tmpl");

		queryDelete.setParam("Mod_Ecr_Id", modeleId);

		var result = queryDelete.execute();
		var errors = new Errors(result);

		if (errors.hasNext()) {
			errors.show();
			activeMenu();
		} else {
			// refresh de la liste
			aListeModeles.deleteTree();
			aListeModeles.initTree();
			// reset
			nouveau();
		}
	} catch (e) {
		recup_erreur(e);
	}
}

function enregistrer() {
	try {
		var qSave = new QueryHttp("Compta/Modele/saveModele.tmpl");

		qSave.setParam("Mod_Ecr_Id", modeleId);
		qSave.setParam("Libelle", document.getElementById('libelle').value);
		qSave.setParam("Raccourci", document.getElementById('raccourci').value);

		var result = qSave.execute();
		var errors = new Errors(result);

		if (errors.hasNext()) {
			errors.show();
			activeMenu();
		} else {
			modeleId = result.responseXML.documentElement.getAttribute('Mod_Ecr_Id');
			aListeModeles.deleteTree();
			aListeModeles.initTree();
			change = false;
			activeMenu();
		}
	} catch (e) {
		recup_erreur(e);
	}
}

function copier() {
	try {
		var queryCopier = new QueryHttp("Compta/Modele/copyModele.tmpl");

		queryCopier.setParam("Mod_Ecr_Id", modeleId);

		var result = queryCopier.execute();
		var errors = new Errors(result);

		if (errors.hasNext()) {
			errors.show();
			activeMenu();
		} else {
			// refresh de la liste
			aListeModeles.deleteTree();
			aListeModeles.initTree();
			// refresh modele
			var id = result.responseXML.documentElement.getAttribute('Mod_Ecr_Id');
			ouvrir(id);
		}
	} catch (e) {
		recup_erreur(e);
	}
}

function valider() {
	try {
		var queryValider = new QueryHttp("Compta/Modele/validateModele.tmpl");

		queryValider.setParam("Mod_Ecr_Id", modeleId);

		var result = queryValider.execute();
		var errors = new Errors(result);

		if (errors.hasNext()) {
			errors.show();
			activeMenu();
		} else {
			// refresh de la liste
			aListeModeles.deleteTree();
			aListeModeles.initTree();
			// refresh modele
			ouvrir(modeleId);
		}
	} catch(e) {
		recup_erreur(e);
	}
}

function keyPressOnCompte(event) {
	try {
		if (event.keyCode==13) {
			rechercheCompte(document.getElementById('compteLigne').value);
		}
	} catch (e) {
		recup_erreur(e);
	}
}


function rechercheCompte(numCompte) {
	try {

		var url = "chrome://opensi/content/compta/user/comptes/popup-rechercheCompte.xul";
   	window.openDialog(url,'','chrome,modal,centerscreen', finRechercheCompte, numCompte, "", "", "", false);

	} catch (e) {
		recup_erreur(e);
	}
}


function finRechercheCompte(numCompte, compteId) {
	try {

		document.getElementById('compteLigne').value = numCompte;

	} catch (e) {
		recup_erreur(e);
	}
}


function selectOnTreeLigne() {
	try {
		loadLigneModele();
	} catch (e) {
		recup_erreur(e);
	}
}

function loadLigneModele() {
	try {
		if (aModeleEcriture.isSelected()) {
			var index = aModeleEcriture.getCurrentIndex();
			ligneId = aModeleEcriture.getCellText(index,'colLigneId');
  			document.getElementById('compteLigne').value = aModeleEcriture.getCellText(index,'colCompte');
			document.getElementById('libelleLigne').value = aModeleEcriture.getCellText(index,'colLibelle');
			document.getElementById('filtreModesLigne').value = (isEmpty(aModeleEcriture.getCellText(index,'colReglementId')))?0:aModeleEcriture.getCellText(index,'colReglementId');
			document.getElementById('infosLigne').value = aModeleEcriture.getCellText(index,'colInfos');
			var debit = aModeleEcriture.getCellText(index,'colDebit');
			var credit = aModeleEcriture.getCellText(index,'colCredit')
			var calcul = aModeleEcriture.getCellText(index,'colCalculId');
			if (calcul=='P') {
				document.getElementById('debitLigne').value = (debit.length==0)?debit:debit.substring(0,debit.length-1);
				document.getElementById('creditLigne').value = (credit.length==0)?credit:credit.substring(0,credit.length-1);
			} else {
				document.getElementById('debitLigne').value = debit;
				document.getElementById('creditLigne').value = credit;
			}
			document.getElementById('pieceLigne').value = aModeleEcriture.getCellText(index,'colPiece');
			document.getElementById('filtreCalculLigne').value = calcul;
			document.getElementById('chkPeriode').checked = (aModeleEcriture.getCellText(index,'colPeriode')!=0);
  		}
	} catch (e) {
		recup_erreur(e);
	}
}

function pressOnAnnulerLigne() {
	try {
		desactiveMenu();
		annulerLigneModele();
		activeMenu();
	} catch (e) {
		recup_erreur(e);
	}
}

function pressOnValiderLigne() {
	try {
		var verif = false;
		// verif compte
		if (!isCompteCorrect(document.getElementById('compteLigne').value)) { showWarning("Num\u00E9ro de compte incorrect !"); }

		// verif libelle
		else if (isEmpty(document.getElementById('libelleLigne').value)) { showWarning("Libell\u00E9 incorrect !"); }

		// verif mode reglement

		// verif infos

		// verif debit (la partie dcimale ne peux faire plus de 2 caractres)
		else if (document.getElementById('filtreCalculLigne').value=='F' && !checkDecimal(document.getElementById('debitLigne').value,2)) { showWarning("Montant au d\u00E9bit incorrect !"); }

		// verif debit (la partie entire ne peux faire plus de 14 caractres)
		else if (document.getElementById('filtreCalculLigne').value=='F' && !checkIPart(document.getElementById('debitLigne').value,14)) { showWarning("Montant au d\u00E9bit incorrect !"); }

		else if (document.getElementById('filtreCalculLigne').value=='P' && !checkDecimal(document.getElementById('debitLigne').value,4)) { showWarning("Pourcentage au d\u00E9bit incorrect !"); }

		// verif debit (positif)
		else if (!isPositiveOrNull(document.getElementById('debitLigne').value)) { showWarning("Montant au d\u00E9bit incorrect : montant n\u00E9gatif !"); }

		// verif credit (la partie dcimale ne peux faire plus de 2 caractres)
		else if (document.getElementById('filtreCalculLigne').value=='F' && !checkDecimal(document.getElementById('creditLigne').value,2)) { showWarning("Montant au cr\u00E9dit incorrect !"); }

		// verif credit (la partie entire ne peux faire plus de 14 caractres)
		else if (document.getElementById('filtreCalculLigne').value=='F' && !checkIPart(document.getElementById('creditLigne').value,14)) { showWarning("Montant au cr\u00E9dit incorrect !"); }

		else if (document.getElementById('filtreCalculLigne').value=='P' && !checkDecimal(document.getElementById('creditLigne').value,4)) { showWarning("Pourcentage au cr\u00E9dit incorrect !"); }

		// verif credit (positif)
		else if (!isPositiveOrNull(document.getElementById('creditLigne').value)) { showWarning("Montant au cr\u00E9dit incorrect : montant n\u00E9gatif !"); }

		// verif debit ou credit : l'un ou l'autre doit tre vide mais pas les deux
		// doubles vides : (d="" || d=0) && (c="" || c=0)
		else if (document.getElementById('filtreCalculLigne').value!='S'
			&& (isEmpty(document.getElementById('debitLigne').value)
				|| document.getElementById('debitLigne').value==0)
			&& (isEmpty(document.getElementById('creditLigne').value)
				|| document.getElementById('creditLigne').value==0)) { showWarning("Veuillez saisir un debit ou un credit !"); }
		// doubles montants : d=x && c=x  <=>  d!="" && d!=0 && c!="" && c!=0
		else if (!isEmpty(document.getElementById('debitLigne').value)
			&& !isEmpty(document.getElementById('creditLigne').value)
			&& document.getElementById('debitLigne').value!=0
			&& document.getElementById('creditLigne').value!=0) { showWarning("Veuillez ne saisir qu'un d\u00E9bit OU un cr\u00E9dit !"); }
		// montants dans une ligne sans montant
		else if (document.getElementById('filtreCalculLigne').value=='S'
			&& ((!isEmpty(document.getElementById('debitLigne').value)
					&& document.getElementById('debitLigne').value!=0)
				|| (!isEmpty(document.getElementById('creditLigne').value)
					&& document.getElementById('creditLigne').value!=0))) { showWarning("Veuillez ne pas saisir de montants dans une ligne sans montant !"); }
		// montant suprieur  100 dans un pourcentage
		else if (document.getElementById('filtreCalculLigne').value=='P'
			&& ((!isEmpty(document.getElementById('debitLigne').value)
					&& document.getElementById('debitLigne').value>100)
				|| (!isEmpty(document.getElementById('creditLigne').value)
					&& document.getElementById('creditLigne').value>100))) { showWarning("Veuillez ne pas saisir de montants sup\u00E9rieurs \u00E0 100 dans une ligne en pourcentage !"); }

		// verif piece

		// verif calcul
		else if (document.getElementById('filtreCalculLigne').selectedIndex==0) { showWarning("Veuillez choisir un type de calcul !"); }

		else { verif = true; }

		if (verif) {
			desactiveMenu();
			saveLigneModele();
			activeMenu();
		}
	} catch (e) {
		recup_erreur(e);
	}
}

function pressOnSupprimerLigne() {
	try {
		if (ligneId!=0) {
			desactiveMenu();
			supprimerLigneModele();
			activeMenu();
		}
	} catch (e) {
		recup_erreur(e);
	}
}

function annulerLigneModele() {
	try {
		// reset la ligne

		// si le modle n'est pas vide, on charge le libelle, le num pice et le type de calcul de la dernire ligne
		if (modeleId!=0 && aModeleEcriture.nbLignes()!=0) {
		var index = aModeleEcriture.nbLignes()-1;
			document.getElementById('libelleLigne').value = aModeleEcriture.getCellText(index,'colLibelle');
			document.getElementById('pieceLigne').value = aModeleEcriture.getCellText(index,'colPiece');
			document.getElementById('filtreCalculLigne').value = aModeleEcriture.getCellText(index,'colCalculId');
			document.getElementById('chkPeriode').checked = (aModeleEcriture.getCellText(index,'colPeriode')!=0);
		} else {
			document.getElementById('libelleLigne').value = "";
			document.getElementById('pieceLigne').value = "";
			document.getElementById('filtreCalculLigne').value = 0;
			document.getElementById('chkPeriode').checked = "true";
		}

		ligneId = 0;
		aModeleEcriture.clearSelection();

		document.getElementById('compteLigne').value = "";
		document.getElementById('filtreModesLigne').value = "0";
		document.getElementById('infosLigne').value = "";
		document.getElementById('debitLigne').value = "0.00";
		document.getElementById('creditLigne').value = "0.00";
	} catch (e) {
		recup_erreur(e);
	}
}

function saveLigneModele() {
	try {
		desactiveMenu();

		var qSave = new QueryHttp("Compta/Modele/saveLigne.tmpl");

		qSave.setParam("Ligne_Id", ligneId);
		qSave.setParam("Mod_Ecr_Id", modeleId);
		qSave.setParam("Numero_Compte", document.getElementById('compteLigne').value);
		qSave.setParam("Libelle", document.getElementById('libelleLigne').value);
		qSave.setParam("Montant_D", document.getElementById('debitLigne').value);
		qSave.setParam("Montant_C", document.getElementById('creditLigne').value);
		qSave.setParam("Mode_Reg_Id", document.getElementById('filtreModesLigne').value);
		qSave.setParam("Commentaire", document.getElementById('infosLigne').value);
		qSave.setParam("Num_Piece", document.getElementById('pieceLigne').value);
		qSave.setParam("Type_Calcul", document.getElementById('filtreCalculLigne').value);
		qSave.setParam("Periode_Lib", document.getElementById('chkPeriode').checked);

		var result = qSave.execute();
		var errors = new Errors(result);

		if (errors.hasNext()) {
			errors.show();
			activeMenu();
		}
		else {
			aListeModeles.deleteTree();
			aListeModeles.initTree();
	  	ouvrir(modeleId);
		}

	} catch (e) {
		recup_erreur(e);
	}
}

function supprimerLigneModele() {
	try {
		desactiveMenu();

		var querySuppr = new QueryHttp("Compta/Modele/deleteLigne.tmpl");

		querySuppr.setParam("Ligne_Id", ligneId);

		var result = querySuppr.execute();
		var errors = new Errors(result);

		if (errors.hasNext()) {
			errors.show();
			activeMenu();
		} else {
			// rafraichir l'arbre
			aListeModeles.deleteTree();
			aListeModeles.initTree();

	  		ouvrir(modeleId);
		}
	} catch (e) {
		recup_erreur(e);
	}
}
