/**********************************************************************************************/
/* OpenSi : Logiciel SaaS de gestion commerciale et comptabilit spcialis dans l'e-commerce */
/* Copyright (c) - Tous droits rservs - SAS Speedinfo Evolution                             */
/**********************************************************************************************/


var oebrc_aBonRetour = new Arbre('Facturation/Affaires/list-ligneRetourClient.tmpl', 'oebrc-bonRetour');
var oebrc_aBonLivraison = new Arbre('Facturation/Affaires/list-articlesNonRetournesBL.tmpl', 'oebrc-bonLivraison');
var oebrc_aVersion = new Arbre("Facturation/Affaires/list-versionRetourClient.tmpl","oebrc-listeVersion");
var oebrc_aLangues = new Arbre("ComboListe/combo-langues.tmpl", "oebrc-langueDefaut");
var oebrc_aDepots = new Arbre('ComboListe/combo-depotsStock.tmpl', 'oebrc-depot');

var oebrc_mode;
var oebrc_clientId = "";
var oebrc_etatBon;
var oebrc_currentCodePaysLiv;
var oebrc_langueDefaut;
var oebrc_curDepot;
var oebrc_typeLiv;
var oebrc_actSuiviSerie;
var oebrc_modified = false;



function oebrc_init() {
  try {

		document.getElementById('oebrc-rowFax').collapsed = !gShowFax;

		oebrc_actSuiviSerie = gConfig.isActSuiviSerie();
		var actSuiviLot = gConfig.isActSuiviLot();
		var actNbPieces = gConfig.isActNbPieces();

		document.getElementById('oebrc-bConsultSerieLigne').collapsed = !oebrc_actSuiviSerie;

		if (!actSuiviLot) {
			document.getElementById('oebrc-colNumLotDev').collapsed = true;
			document.getElementById('oebrc-colNumLotDev').setAttribute('ignoreincolumnpicker', true);
			document.getElementById('oebrc-colDatePeremptionDev').collapsed = true;
			document.getElementById('oebrc-colDatePeremptionDev').setAttribute('ignoreincolumnpicker', true);
			document.getElementById('oebrc-colNumLotLiv').collapsed = true;
			document.getElementById('oebrc-colNumLotLiv').setAttribute('ignoreincolumnpicker', true);
			document.getElementById('oebrc-colDatePeremptionLiv').collapsed = true;
			document.getElementById('oebrc-colDatePeremptionLiv').setAttribute('ignoreincolumnpicker', true);
		}

		if (!actNbPieces) {
			document.getElementById('oebrc-colNbPiecesDev').collapsed = true;
			document.getElementById('oebrc-colNbPiecesDev').setAttribute('ignoreincolumnpicker', true);
			document.getElementById('oebrc-colNbPiecesLiv').collapsed = true;
			document.getElementById('oebrc-colNbPiecesLiv').setAttribute('ignoreincolumnpicker', true);
			document.getElementById('oebrc-rowNbPieces').collapsed = true;
		}

		var aPaysLiv = new Arbre("ComboListe/combo-pays.tmpl", "oebrc-codePaysLiv");
		aPaysLiv.initTree(oebrc_initPaysLiv);

		if (gReadOnly) {
			document.getElementById('oebrc-bEnregistrer').collapsed = true;
			document.getElementById('oebrc-bImporterLignes').collapsed = true;
			document.getElementById('oebrc-tabBon').setAttribute('tooltiptext', "Lecture seule");
		}

  } catch (e) {
  	recup_erreur(e);
  }
}


function oebrc_initPaysLiv() {
	try {

		document.getElementById('oebrc-codePaysLiv').value = "FR";

	} catch (e) {
    recup_erreur(e);
  }
}


function oebrc_chargerDepot(selection) {
	try {

		oebrc_curDepot = selection;
		oebrc_aDepots.setParam("Selection", selection);
		oebrc_aDepots.setParam("Depot_Vente", false);
		oebrc_aDepots.setParam("Depot_Quarantaine", true);
		oebrc_aDepots.initTree(oebrc_initDepot);

	} catch (e) {
		recup_erreur(e);
	}
}


function oebrc_initDepot() {
	try {

		document.getElementById('oebrc-depot').value = oebrc_curDepot;

	} catch (e) {
		recup_erreur(e);
	}
}


function oebrc_reinitialiser() {
	try {

		oebrc_mode = "C";
		oebrc_etatBon = "N";
		oebrc_clientId = "";
		oebrc_curDepot = "";
		oebrc_typeLiv = "";
		document.getElementById('oebrc-deckBonRetour').selectedIndex = 0;
		document.getElementById('oebrc-tabBoxBon').selectedIndex = 0;
		document.getElementById('oebrc-numClient').value = "";
		document.getElementById('oebrc-labelLogin').value = "";
		document.getElementById('oebrc-rowLoginWeb').collapsed = true;
		document.getElementById('oebrc-refRetourWeb').value = "";
		document.getElementById('oebrc-rowRefRetourWeb').collapsed = true;
		document.getElementById('oebrc-raisonSociale').value = "";
		document.getElementById('oebrc-adresseFact').value = "";
		document.getElementById('oebrc-adresse2Fact').value = "";
		document.getElementById('oebrc-adresse3Fact').value = "";
		document.getElementById('oebrc-codePostalFact').value = "";
		document.getElementById('oebrc-villeFact').value = "";
		document.getElementById('oebrc-affaire').value = "";
		document.getElementById('oebrc-denominationLiv').value = "";
		document.getElementById('oebrc-adresse1Liv').value = "";
		document.getElementById('oebrc-adresse2Liv').value = "";
		document.getElementById('oebrc-adresse3Liv').value = "";
		document.getElementById('oebrc-codePostalLiv').value = "";
		document.getElementById('oebrc-villeLiv').value = "";
		document.getElementById('oebrc-codePaysLiv').value = "FR";
		document.getElementById('oebrc-civInterLiv').value = "0";
		document.getElementById('oebrc-nomInterLiv').value = "";
		document.getElementById('oebrc-prenomInterLiv').value = "";
		document.getElementById('oebrc-telInter1Liv').value = "";
		document.getElementById('oebrc-telInter2Liv').value = "";
		document.getElementById('oebrc-faxInterLiv').value = "";
		document.getElementById('oebrc-emailInterLiv').value = "";
		document.getElementById('oebrc-tabBon').setAttribute('image', gReadOnly?'chrome://opensi/content/design/icones/readonly.png':null);

		oebrc_aDepots.deleteTree();
		document.getElementById('oebrc-depot').value = "";

		document.getElementById('oebrc-tabVersionDocument').collapsed=true;
		oebrc_aVersion.deleteTree();

		document.getElementById('oebrc-tabBoxAdresses').selectedIndex = 1;

		document.getElementById('oebrc-numero').value = "";
		document.getElementById('oebrc-dateRetour').value = "";
		document.getElementById('oebrc-etat').value = "";
		document.getElementById('oebrc-dateReception').value = "";
		document.getElementById('oebrc-commentairesFin').value = "";
		document.getElementById('oebrc-commentairesInt').value = "";
		document.getElementById('oebrc-nbPieces').value = "";
		document.getElementById('oebrc-quantite').value = "";
		document.getElementById('oebrc-creation').value = "";
		document.getElementById('oebrc-modification').value = "";
		document.getElementById('oebrc-fiche').value = "";
		document.getElementById('oebrc-typeRetour').selectedIndex = -1;
		oebrc_modified = false;

		document.getElementById('oebrc-chercherAdrLiv').disabled = true;
		document.getElementById('oebrc-chercherInterLiv').disabled = true;
		document.getElementById('oebrc-bChoisirMentions').disabled = true;
		document.getElementById('oebrc-bAjouter').disabled = true;
		document.getElementById('oebrc-bToutAjouter').disabled = true;
		document.getElementById('oebrc-bEnlever').disabled = true;
		document.getElementById('oebrc-bToutEnlever').disabled = true;
		document.getElementById('oebrc-bEnregistrer').disabled = true;
		document.getElementById('oebrc-bValiderBR').disabled = true;
		document.getElementById('oebrc-bValiderReception').disabled = true;
		document.getElementById('oebrc-bAnnuler').disabled = true;
		document.getElementById('oebrc-bSupprimer').disabled = true;
		document.getElementById('oebrc-bVisualiser').disabled = true;

		document.getElementById('oebrc-denominationLiv').setAttribute('readonly', true);
		document.getElementById('oebrc-adresse1Liv').setAttribute('readonly', true);
		document.getElementById('oebrc-adresse2Liv').setAttribute('readonly', true);
		document.getElementById('oebrc-adresse3Liv').setAttribute('readonly', true);
		document.getElementById('oebrc-codePostalLiv').setAttribute('readonly', true);
		document.getElementById('oebrc-villeLiv').setAttribute('readonly', true);
		document.getElementById('oebrc-codePaysLiv').disabled = true;
		document.getElementById('oebrc-civInterLiv').disabled = true;
		document.getElementById('oebrc-nomInterLiv').setAttribute('readonly', true);
		document.getElementById('oebrc-prenomInterLiv').setAttribute('readonly', true);
		document.getElementById('oebrc-telInter1Liv').setAttribute('readonly', true);
		document.getElementById('oebrc-telInter2Liv').setAttribute('readonly', true);
		document.getElementById('oebrc-faxInterLiv').setAttribute('readonly', true);
		document.getElementById('oebrc-emailInterLiv').setAttribute('readonly', true);

		document.getElementById('oebrc-commentairesFin').disabled = true;
		document.getElementById('oebrc-commentairesInt').disabled = true;
		document.getElementById('oebrc-nbPieces').disabled = true;
		document.getElementById('oebrc-quantite').disabled = true;
		document.getElementById('oebrc-bonLivraison').disabled = true;
		document.getElementById('oebrc-depot').disabled = true;
		document.getElementById('oebrc-typeRetour').disabled = true;

		document.getElementById('oebrc-bOuvrirCommentairesCaches').disabled = true;

		document.getElementById('oebrc-bConsultSerieLigne').disabled = true;
		document.getElementById('oebrc-bImporterLignes').disabled = true;

		document.getElementById('oebrc-bVisualiser').collapsed = true;
		document.getElementById('oebrc-bValiderBR').collapsed = true;
		document.getElementById('oebrc-bValiderReception').collapsed = true;

		oebrc_aBonRetour.deleteTree();
		oebrc_aBonLivraison.deleteTree();

	} catch (e) {
		recup_erreur(e);
	}
}


function oebrc_debloquerChamps() {
	try {

		document.getElementById('oebrc-chercherAdrLiv').disabled = false;
		document.getElementById('oebrc-chercherInterLiv').disabled = false;
		document.getElementById('oebrc-bChoisirMentions').disabled = false;
		document.getElementById('oebrc-bAjouter').disabled = false;
		document.getElementById('oebrc-bToutAjouter').disabled = false;
		document.getElementById('oebrc-bEnlever').disabled = false;

		document.getElementById('oebrc-denominationLiv').removeAttribute('readonly');
		document.getElementById('oebrc-adresse1Liv').removeAttribute('readonly');
		document.getElementById('oebrc-adresse2Liv').removeAttribute('readonly');
		document.getElementById('oebrc-adresse3Liv').removeAttribute('readonly');
		document.getElementById('oebrc-codePostalLiv').removeAttribute('readonly');
		document.getElementById('oebrc-villeLiv').removeAttribute('readonly');
		document.getElementById('oebrc-codePaysLiv').disabled = false;
		document.getElementById('oebrc-civInterLiv').disabled = false;
		document.getElementById('oebrc-nomInterLiv').removeAttribute('readonly');
		document.getElementById('oebrc-prenomInterLiv').removeAttribute('readonly');
		document.getElementById('oebrc-telInter1Liv').removeAttribute('readonly');
		document.getElementById('oebrc-telInter2Liv').removeAttribute('readonly');
		document.getElementById('oebrc-faxInterLiv').removeAttribute('readonly');
		document.getElementById('oebrc-emailInterLiv').removeAttribute('readonly');

		document.getElementById('oebrc-commentairesFin').disabled = false;
		document.getElementById('oebrc-commentairesInt').disabled = false;
		document.getElementById('oebrc-nbPieces').disabled = false;
		document.getElementById('oebrc-quantite').disabled = false;
		document.getElementById('oebrc-codePaysLiv').disabled = false;
		document.getElementById('oebrc-bonLivraison').disabled = false;
		document.getElementById('oebrc-bEnregistrer').disabled = false;
		document.getElementById('oebrc-bSupprimer').disabled = false;
		document.getElementById('oebrc-bValiderReception').disabled = false;
		document.getElementById('oebrc-depot').disabled = false;
		document.getElementById('oebrc-typeRetour').disabled = false;

		oebrc_disableAjouter(true,false);
		oebrc_disableEnlever(true,false);

	} catch (e) {
    recup_erreur(e);
  }
}

function oebrc_reporterQteEntree() {
	try {

		if (oebrc_aBonLivraison.isSelected()) {
			document.getElementById('oebrc-nbPieces').value = oebrc_aBonLivraison.getSelectedCellText('oebrc-colNbPiecesDev');
			document.getElementById('oebrc-quantite').value = oebrc_aBonLivraison.getSelectedCellText('oebrc-colQuantiteDev');
		}

	} catch (e) {
    recup_erreur(e);
  }
}


function oebrc_reporterQteSortie() {
	try {

		if (oebrc_aBonRetour.isSelected()) {
			document.getElementById('oebrc-nbPieces').value = oebrc_aBonRetour.getSelectedCellText('oebrc-colNbPiecesLiv');
			document.getElementById('oebrc-quantite').value = oebrc_aBonRetour.getSelectedCellText('oebrc-colQuantiteLiv');
		}

	} catch (e) {
    recup_erreur(e);
  }
}


function oebrc_disableAjouter(oebrc_b,oebrc_arbre) {
	try {

		if (!oebrc_arbre || (oebrc_aBonLivraison.isSelected() && oebrc_mode!="V")) {
			document.getElementById('oebrc-bAjouter').disabled = oebrc_b;
		}

	} catch (e) {
    recup_erreur(e);
  }
}


function oebrc_disableEnlever(oebrc_b,oebrc_arbre) {
	try {

		if (!oebrc_arbre || (oebrc_aBonRetour.isSelected() && oebrc_mode!="V")) {
			document.getElementById('oebrc-bEnlever').disabled = oebrc_b;
		}

	} catch (e) {
    recup_erreur(e);
  }
}


function oebrc_selectionArticleBonLiv() {
	try {

		if (oebrc_aBonLivraison.isSelected()) {
			oebrc_reporterQteEntree();
			oebrc_disableAjouter(false,true);
			oebrc_disableEnlever(true,false);
		}

	} catch (e) {
		recup_erreur(e);
	}
}


function oebrc_nouveauBon() {
  try {

		oebrc_aBonLivraison.clearParams();
		oebrc_reinitialiser();

		oebrc_mode = "C";

		var oebrc_qDefautAdresse = new QueryHttp('Facturation/Affaires/getAdresseBL.tmpl');
		oebrc_qDefautAdresse.setParam('Bon_Id', bonId);
		var result = oebrc_qDefautAdresse.execute();

		var contenu = result.responseXML.documentElement;

		oebrc_typeLiv = contenu.getAttribute('Type_Liv');
		commandeId = contenu.getAttribute('Commande_Id');
		oebrc_clientId = contenu.getAttribute('Client_Id');
		document.getElementById('oebrc-numClient').value = contenu.getAttribute('Num_Client');
		document.getElementById('oebrc-denominationLiv').value = contenu.getAttribute('Denomination_Liv');
		document.getElementById('oebrc-adresse1Liv').value = contenu.getAttribute('Adresse_1_Liv');
		document.getElementById('oebrc-adresse2Liv').value = contenu.getAttribute('Adresse_2_Liv');
		document.getElementById('oebrc-adresse3Liv').value = contenu.getAttribute('Adresse_3_Liv');
		document.getElementById('oebrc-codePostalLiv').value = contenu.getAttribute('Code_Postal_Liv');
		document.getElementById('oebrc-villeLiv').value = contenu.getAttribute('Ville_Liv');
		document.getElementById('oebrc-codePaysLiv').value = contenu.getAttribute('Code_Pays_Liv');

		document.getElementById('oebrc-civInterLiv').value = contenu.getAttribute("Civ_Inter_Liv");
		document.getElementById('oebrc-nomInterLiv').value = contenu.getAttribute("Nom_Inter_Liv");
		document.getElementById('oebrc-prenomInterLiv').value = contenu.getAttribute("Prenom_Inter_Liv");
		document.getElementById('oebrc-telInter1Liv').value = contenu.getAttribute("Tel_Inter_1_Liv");
		document.getElementById('oebrc-telInter2Liv').value = contenu.getAttribute("Tel_Inter_2_Liv");
		document.getElementById('oebrc-faxInterLiv').value = contenu.getAttribute("Fax_Inter_Liv");
		document.getElementById('oebrc-emailInterLiv').value = contenu.getAttribute("Email_Inter_Liv");

		oebrc_chargerDepot(contenu.getAttribute("Depot_Id"));

		oebrc_aBonRetour.deleteTree();
		oebrc_aBonLivraison.setParam("Bon_Liv_Id", bonId);
		oebrc_aBonLivraison.initTree();
		document.getElementById('oebrc-bVisualiser').collapsed = false;

		oebrc_setModified(false);
		document.getElementById('oebrc-bSupprimer').collapsed = true;
		document.getElementById('oebrc-bAnnuler').collapsed = true;
		oebrc_debloquerChamps();

		document.getElementById('oebrc-bEnregistrer').disabled = false;
		document.getElementById('oebrc-bValiderBR').disabled = true;
		document.getElementById('oebrc-bVisualiser').disabled = true;
		document.getElementById('oebrc-corpsBL').collapsed = false;
		document.getElementById('oebrc-boxActions').collapsed = gReadOnly;

		document.getElementById('oebrc-affaire').value = ofa_numAffaire;

	} catch (e) {
  	recup_erreur(e);
  }
}


function oebrc_chargerBon() {
  try {

		oebrc_reinitialiser();
  	oebrc_aBonLivraison.setParam('Retour_Id', retourId);
		oebrc_aBonRetour.setParam('Retour_Id', retourId);

		document.getElementById('oebrc-bVisualiser').collapsed = false;

		oebrc_mode = "M";
		var oebrc_qGetBonRetour = new QueryHttp('Facturation/Affaires/loadRetourClient.tmpl');
		oebrc_qGetBonRetour.setParam("Retour_Id", retourId);
		var result = oebrc_qGetBonRetour.execute();
		var contenu = result.responseXML.documentElement;

		oebrc_typeLiv = contenu.getAttribute('Type_Liv');
		oebrc_etatBon = contenu.getAttribute("Etat");
		commandeId = contenu.getAttribute("Commande_Id");
		affaireId = contenu.getAttribute("Affaire_Id");
		bonId = contenu.getAttribute("Bon_Liv_Id");

		document.getElementById('oebrc-bAnnuler').disabled = (ofa_etatAffaire=="C" || (oebrc_etatBon!="E" && oebrc_etatBon!="V"));

		if (oebrc_etatBon=="V" || oebrc_etatBon=="E") {
			document.getElementById('oebrc-etat').value = (oebrc_etatBon=="V"?"Cl\u00F4tur\u00E9":"En attente");
			document.getElementById('oebrc-bSupprimer').collapsed = true;
			document.getElementById('oebrc-bAnnuler').collapsed = (ofa_etatAffaire=="C" || gReadOnly);
			document.getElementById('oebrc-corpsBL').collapsed = true;
			document.getElementById('oebrc-boxActions').collapsed = true;
		}
		else if (oebrc_etatBon=="A") {
			document.getElementById('oebrc-etat').value = "Annul\u00E9";
			document.getElementById('oebrc-bSupprimer').collapsed = true;
			document.getElementById('oebrc-bAnnuler').collapsed = true;
			document.getElementById('oebrc-corpsBL').collapsed = true;
			document.getElementById('oebrc-boxActions').collapsed = true;
		}
		else {
			document.getElementById('oebrc-etat').value = "Non valid\u00E9";
			document.getElementById('oebrc-bAnnuler').collapsed = true;
			document.getElementById('oebrc-bSupprimer').collapsed = gReadOnly;
			document.getElementById('oebrc-corpsBL').collapsed = false;
			document.getElementById('oebrc-boxActions').collapsed = gReadOnly;
			document.getElementById('oebrc-bImporterLignes').disabled = false;
		}

		document.getElementById('oebrc-bVisualiser').collapsed = (oebrc_etatBon=='N');
		document.getElementById('oebrc-bValiderBR').collapsed = (oebrc_etatBon!='N' || gReadOnly);
		document.getElementById('oebrc-bValiderReception').collapsed = (oebrc_etatBon!='E' || gReadOnly);

		document.getElementById('oebrc-dateReception').value = contenu.getAttribute("Date_Retour");
		document.getElementById('oebrc-raisonSociale').value = contenu.getAttribute("Denomination");
		document.getElementById('oebrc-adresseFact').value = contenu.getAttribute("Adresse_1");
		document.getElementById('oebrc-adresse2Fact').value = contenu.getAttribute("Adresse_2");
		document.getElementById('oebrc-adresse3Fact').value = contenu.getAttribute("Adresse_3");
		document.getElementById('oebrc-codePostalFact').value = contenu.getAttribute("Code_Postal");
		document.getElementById('oebrc-villeFact').value = contenu.getAttribute("Ville");
		oebrc_clientId = contenu.getAttribute("Client_Id");
		document.getElementById('oebrc-numClient').value = contenu.getAttribute("Num_Client");
		document.getElementById('oebrc-labelLogin').value = contenu.getAttribute("Login_Web");
		document.getElementById('oebrc-rowLoginWeb').collapsed = (contenu.getAttribute("Web")=="false");
		var refRetourWeb = contenu.getAttribute("Ref_Retour_Web");
		document.getElementById('oebrc-refRetourWeb').value = refRetourWeb;
		document.getElementById('oebrc-rowRefRetourWeb').collapsed = isEmpty(refRetourWeb);
		document.getElementById('oebrc-affaire').value = contenu.getAttribute("Num_Affaire");

		document.getElementById('oebrc-dateRetour').value = contenu.getAttribute("Date_Bon");
		document.getElementById('oebrc-denominationLiv').value = contenu.getAttribute("Denomination_Liv");
		document.getElementById('oebrc-adresse1Liv').value = contenu.getAttribute("Adresse_1_Liv");
		document.getElementById('oebrc-adresse2Liv').value = contenu.getAttribute("Adresse_2_Liv");
		document.getElementById('oebrc-adresse3Liv').value = contenu.getAttribute("Adresse_3_Liv");
		document.getElementById('oebrc-codePostalLiv').value = contenu.getAttribute("Code_Postal_Liv");
		document.getElementById('oebrc-villeLiv').value = contenu.getAttribute("Ville_Liv");
		document.getElementById('oebrc-codePaysLiv').value = contenu.getAttribute("Code_Pays_Liv");
		document.getElementById('oebrc-commentairesFin').value = contenu.getAttribute("Commentaires_Fin");
		document.getElementById('oebrc-commentairesInt').value = contenu.getAttribute("Commentaires_Int");
		document.getElementById('oebrc-numero').value = contenu.getAttribute("Num_Retour");
		document.getElementById('oebrc-typeRetour').value = contenu.getAttribute("Type_Retour");

		document.getElementById('oebrc-civInterLiv').value = contenu.getAttribute("Civ_Inter_Liv");
		document.getElementById('oebrc-nomInterLiv').value = contenu.getAttribute("Nom_Inter_Liv");
		document.getElementById('oebrc-prenomInterLiv').value = contenu.getAttribute("Prenom_Inter_Liv");
		document.getElementById('oebrc-telInter1Liv').value = contenu.getAttribute("Tel_Inter_1_Liv");
		document.getElementById('oebrc-telInter2Liv').value = contenu.getAttribute("Tel_Inter_2_Liv");
		document.getElementById('oebrc-faxInterLiv').value = contenu.getAttribute("Fax_Inter_Liv");
		document.getElementById('oebrc-emailInterLiv').value = contenu.getAttribute("Email_Inter_Liv");

		oebrc_chargerDepot(contenu.getAttribute("Depot_Id"));

		document.getElementById('oebrc-creation').setAttribute("label","Retour cr\u00E9\u00E9 le "+ contenu.getAttribute('Date_Creation') +" par "+ contenu.getAttribute('Login_Creation'));
		document.getElementById('oebrc-modification').setAttribute("label","Derni\u00E8re modification le "+ contenu.getAttribute('Date_Maj') +" par "+ contenu.getAttribute('Login_Maj'));
		document.getElementById('oebrc-fiche').setAttribute("label","Retour N\u00B0 "+ contenu.getAttribute('Num_Retour'));
		document.getElementById('oebrc-creation').collapsed = false;
		document.getElementById('oebrc-modification').collapsed = false;

		document.getElementById('oebrc-bOuvrirCommentairesCaches').disabled = false;

		oebrc_aBonRetour.initTree();

		if (oebrc_etatBon!='N') {
			document.getElementById('oebrc-tabVersionDocument').collapsed=false;
			oebrc_initVersion();
		}

		oebrc_setModified(false);
		if (oebrc_etatBon!='V' && oebrc_etatBon!='E' && oebrc_etatBon!='A') {
			oebrc_aBonLivraison.setParam("Bon_Liv_Id", bonId);
			oebrc_aBonLivraison.initTree();
			oebrc_debloquerChamps();
			document.getElementById('oebrc-bToutEnlever').disabled = false;
		} else if (oebrc_etatBon=='E') {
			document.getElementById('oebrc-bValiderReception').disabled = false;
		}

	} catch (e) {
  	recup_erreur(e);
  }
}


function oebrc_editerCommentairesInternes() {
  try {

  	var url = "chrome://opensi/content/facturation/user/commun/popup-commentairesInternes.xul";
  	window.openDialog(url,'','chrome,modal,centerscreen', "RC", retourId, gReadOnly);

	} catch (e) {
  	recup_erreur(e);
  }
}


function oebrc_editerCommentairesDocument() {
  try {

		var commentairesFin = document.getElementById('oebrc-commentairesFin').value;
		var commentairesInt = document.getElementById('oebrc-commentairesInt').value;
		var readOnly = (oebrc_etatBon!="N" || gReadOnly);

		var url = "chrome://opensi/content/facturation/user/commun/popup-commentairesDocument.xul";
  	window.openDialog(url,'','chrome,modal,centerscreen', oebrc_retourEditerCommentaires, "RC", retourId, commentairesFin, commentairesInt, readOnly);

	} catch (e) {
    recup_erreur(e);
  }
}


function oebrc_retourEditerCommentaires(commentairesFin, commentairesInt) {
  try {

		document.getElementById('oebrc-commentairesFin').value = commentairesFin;
		document.getElementById('oebrc-commentairesInt').value = commentairesInt;

	} catch (e) {
    recup_erreur(e);
  }
}


function oebrc_enregistrerBon(rafraichir) {
  try {

  	var oebrc_ok=false;

		var oebrc_qBonRetour;

		if (oebrc_mode=="C") {
			oebrc_qBonRetour = new QueryHttp("Facturation/Affaires/createRetourClient.tmpl");
			oebrc_qBonRetour.setParam("Bon_Liv_Id", bonId);
		}
		else {
			oebrc_qBonRetour = new QueryHttp("Facturation/Affaires/updateRetourClient.tmpl");
			oebrc_qBonRetour.setParam("Retour_Id", retourId);
		}

		var oebrc_denomination = document.getElementById('oebrc-denominationLiv').value;
		var oebrc_adresse1 = document.getElementById('oebrc-adresse1Liv').value;
		var oebrc_adresse2 = document.getElementById('oebrc-adresse2Liv').value;
		var oebrc_adresse3 = document.getElementById('oebrc-adresse3Liv').value;
		var oebrc_codePostal = document.getElementById('oebrc-codePostalLiv').value;
		var oebrc_ville = document.getElementById('oebrc-villeLiv').value;
		var oebrc_codePays = document.getElementById('oebrc-codePaysLiv').value;
		var oebrc_civInter = document.getElementById('oebrc-civInterLiv').value;
		var oebrc_nomInter = document.getElementById('oebrc-nomInterLiv').value;
		var oebrc_prenomInter = document.getElementById('oebrc-prenomInterLiv').value;
		var oebrc_telInter1 = document.getElementById('oebrc-telInter1Liv').value;
		var oebrc_telInter2 = document.getElementById('oebrc-telInter2Liv').value;
		var oebrc_faxInter = document.getElementById('oebrc-faxInterLiv').value;
		var oebrc_emailInter = document.getElementById('oebrc-emailInterLiv').value;
		var oebrc_commentairesFin = document.getElementById('oebrc-commentairesFin').value;
		var oebrc_commentairesInt = document.getElementById('oebrc-commentairesInt').value;
		var oebrc_depot = document.getElementById('oebrc-depot').value;
		var oebrc_typeRetour = document.getElementById('oebrc-typeRetour').value;

		if (isEmpty(oebrc_denomination)) { showWarning("Veuillez indiquer la d\u00E9nomination du client !"); }
		else if (isEmpty(oebrc_adresse1)) { showWarning("Veuillez indiquer l'adresse du client !"); }
		else if (isEmpty(oebrc_ville)) { showWarning("Veuillez indiquer la ville du client !"); }
		else if (!isEmpty(oebrc_telInter1) && !isPhone(oebrc_telInter1)) { showWarning("T\u00E9l\u00E9phone 1 incorrect !"); }
		else if (!isEmpty(oebrc_telInter2) && !isPhone(oebrc_telInter2)) { showWarning("T\u00E9l\u00E9phone 2 incorrect !"); }
		else if (gShowFax && !isEmpty(oebrc_faxInter) && !isPhone(oebrc_faxInter)) { showWarning("Num\u00E9ro de fax incorrect !"); }
		else if (!isEmpty(oebrc_emailInter) && !isEmail(oebrc_emailInter)) { showWarning("Adresse e-mail incorrecte !"); }
		else if (isEmpty(oebrc_depot)) { showWarning("Veuillez choisir un d\u00E9p\u00F4t de r\u00E9ception."); }
		else if (isEmpty(oebrc_typeRetour) || document.getElementById('oebrc-typeRetour').selectedIndex==-1) { showWarning("Veuillez choisir un type de retour"); }
		else {
			oebrc_qBonRetour.setParam("Denomination",oebrc_denomination);
			oebrc_qBonRetour.setParam("Adresse_1",oebrc_adresse1);
			oebrc_qBonRetour.setParam("Adresse_2",oebrc_adresse2);
			oebrc_qBonRetour.setParam("Adresse_3",oebrc_adresse3);
			oebrc_qBonRetour.setParam("Code_Postal",oebrc_codePostal);
			oebrc_qBonRetour.setParam("Ville",oebrc_ville);
			oebrc_qBonRetour.setParam("Code_Pays",oebrc_codePays);
			oebrc_qBonRetour.setParam("Civ_Inter",oebrc_civInter);
			oebrc_qBonRetour.setParam("Nom_Inter",oebrc_nomInter);
			oebrc_qBonRetour.setParam("Prenom_Inter",oebrc_prenomInter);
			oebrc_qBonRetour.setParam("Tel_Inter_1", oebrc_telInter1);
			oebrc_qBonRetour.setParam("Tel_Inter_2", oebrc_telInter2);
			oebrc_qBonRetour.setParam("Fax_Inter",oebrc_faxInter);
			oebrc_qBonRetour.setParam("Email_Inter",oebrc_emailInter);
			oebrc_qBonRetour.setParam("Commentaires_Fin",oebrc_commentairesFin);
			oebrc_qBonRetour.setParam("Commentaires_Int",oebrc_commentairesInt);
			oebrc_qBonRetour.setParam("Depot_Id",oebrc_depot);
			oebrc_qBonRetour.setParam("Type_Retour",oebrc_typeRetour);

			var result = oebrc_qBonRetour.execute();
			var contenu = result.responseXML.documentElement;

			if (oebrc_mode=="C") {
				retourId = contenu.getAttribute("Retour_Id");
				if (rafraichir) { oebrc_chargerBon(); }
			}

			oebrc_setModified(false);
			oebrc_ok=true;
		}
		return oebrc_ok;

	} catch (e) {
  	recup_erreur(e);
  }
}


function oebrc_supprimerBon() {
  try {

		if (window.confirm("Confirmez-vous la suppression de ce retour ?")) {
			var oebrc_qSupBR = new QueryHttp("Facturation/Affaires/deleteRetourClient.tmpl");
			oebrc_qSupBR.setParam("Retour_Id", retourId);
			oebrc_qSupBR.execute();

			showMessage("Le retour a \u00E9t\u00E9 supprim\u00E9 avec succ\u00E8s !");

			retourFicheAffaire();
		}

	} catch (e) {
  	recup_erreur(e);
  }
}


function oebrc_toutTransferer() {
  try {
  	var ok = true;
		if (oebrc_mode=="C") {
			ok = oebrc_enregistrerBon(true);
		}
		if (ok) {
			var oebrc_qAjouterToutBon = new QueryHttp('Facturation/Affaires/addAllRC.tmpl');
			oebrc_qAjouterToutBon.setParam("Retour_Id", retourId);
			oebrc_qAjouterToutBon.setParam("Bon_Liv_Id", bonId);
			oebrc_qAjouterToutBon.execute();

			oebrc_aBonLivraison.initTree();
			oebrc_aBonRetour.initTree();
		}

	} catch (e) {
  	recup_erreur(e);
	}
}


function oebrc_toutEnlever() {
  try {

  	var oebrc_qEnleverToutBon = new QueryHttp('Facturation/Affaires/removeAllRC.tmpl');
		oebrc_qEnleverToutBon.setParam("Retour_Id", retourId);
		oebrc_qEnleverToutBon.execute();

		oebrc_aBonLivraison.initTree();
		oebrc_aBonRetour.initTree();
		document.getElementById("oebrc-bConsultSerieLigne").disabled = true;

	} catch (e) {
  	recup_erreur(e);
	}
}


function oebrc_ajouter() {
  try {

		if (oebrc_aBonLivraison.isSelected()) {

			var ligneBL = oebrc_aBonLivraison.getSelectedCellText('oebrc-colLigneIdDev');
			var qteRestante = oebrc_aBonLivraison.getSelectedCellText('oebrc-colQuantiteDev');
			var isSuiviSerie = oebrc_aBonLivraison.getSelectedCellText('oebrc-colSuiviSerieDev')=="true";
			var nbPiecesRestant = oebrc_aBonLivraison.getSelectedCellText('oebrc-colNbPiecesDev');
			if (isEmpty(nbPiecesRestant)) { nbPiecesRestant = 0; }

			var quantite = document.getElementById('oebrc-quantite').value;
			var nbPieces = document.getElementById('oebrc-nbPieces').value;
			if (isEmpty(nbPieces)) { nbPieces = 0; }

			if (isEmpty(quantite)) { showWarning("Veuillez entrer une quantit\u00E9 \u00E0 transf\u00E9rer !"); }
			else if (!checkQte(quantite)) { showWarning("Quantit\u00E9 incorrecte !"); }
			else if (!isPositiveOrNullInteger(nbPieces)) { showWarning("Nombre de pi\u00E8ces incorrect !");	}
			else if (parseFloat(qteRestante)-parseFloat(quantite)<0) { showWarning("La quantit\u00E9 \u00E0 transf\u00E9rer ne doit pas d\u00E9passer la quantit\u00E9 restant \u00E0 retourner !"); }
			else if (parseFloat(nbPiecesRestant)-parseFloat(nbPieces)<0) { showWarning("Le nb de pi\u00E8ces \u00E0 transf\u00E9rer ne doit pas d\u00E9passer le nb de pi\u00E8ces restant \u00E0 retourner !"); }
			else {

				var ok = true;

				if (oebrc_mode=="C") {
					ok = oebrc_enregistrerBon(true);
				}

				if (ok) {
					var qAdd = new QueryHttp('Facturation/Affaires/addLigneRC.tmpl');
					qAdd.setParam("Retour_Id", retourId);
					qAdd.setParam("Ligne_BL", ligneBL);
					qAdd.setParam("Quantite", quantite);
					qAdd.setParam("Nb_Pieces", nbPieces);
					var result = qAdd.execute();

					var ligneRC = result.responseXML.documentElement.getAttribute('Ligne_Id');
					var quantiteRC = parseIntBis(result.responseXML.documentElement.getAttribute('Quantite'));

					oebrc_aBonLivraison.initTree();
					oebrc_aBonRetour.initTree();
					oebrc_disableAjouter(true,false);

					oebrc_checkNumSerieLigne(ligneRC, isSuiviSerie, quantiteRC);
				}
			}
		}

	} catch (e) {
  	recup_erreur(e);
	}
}


function oebrc_enlever() {
  try {

		if (oebrc_aBonRetour.isSelected()) {
			var i = oebrc_aBonRetour.getCurrentIndex();
			var oebrc_ligneId = oebrc_aBonRetour.getCellText(i, 'oebrc-colLigneIdLiv');
			var oebrc_qteInit = oebrc_aBonRetour.getCellText(i, 'oebrc-colQuantiteLiv');
			var oebrc_quantite = document.getElementById('oebrc-quantite').value;
			var oebrc_nbPiecesInit = oebrc_aBonRetour.getCellText(i, 'oebrc-colNbPiecesLiv');
			if (isEmpty(oebrc_nbPiecesInit)) { oebrc_nbPiecesInit = 0; }
			var oebrc_nbPieces = document.getElementById('oebrc-nbPieces').value;
			if (isEmpty(oebrc_nbPieces)) { oebrc_nbPieces = 0; }

			if (isEmpty(oebrc_quantite)) { showWarning("Veuillez entrer une quantit\u00E9 \u00E0 enlever"); }
			else if (!checkQte(oebrc_quantite)) { showWarning("Quantit\u00E9 incorrecte !"); }
			else if (parseFloat(oebrc_qteInit)-parseFloat(oebrc_quantite)<0) { showWarning("La quantit\u00E9 \u00E0 enlever ne peut d\u00E9passer la quantit\u00E9 pr\u00E9sente dans le retour !"); }
			else if (!isPositiveOrNullInteger(oebrc_nbPieces)) { showWarning("Nombre de pi\u00E8ces incorrect !");	}
			else if ((parseFloat(oebrc_nbPiecesInit)-parseFloat(oebrc_nbPieces)<0)) { showWarning("Le nb de pi\u00E8ces \u00E0 enlever ne peut d\u00E9passer le nb de pi\u00E8ces pr\u00E9sent dans le retour !"); }
			else {
				var oebrc_qEnleverArticles = new QueryHttp('Facturation/Affaires/removeLigneRC.tmpl');
				oebrc_qEnleverArticles.setParam("Ligne_Id", oebrc_ligneId);
				oebrc_qEnleverArticles.setParam("QteInit", oebrc_qteInit);
				oebrc_qEnleverArticles.setParam("Quantite", oebrc_quantite);
				oebrc_qEnleverArticles.setParam("Nb_Pieces", oebrc_nbPieces);
				oebrc_qEnleverArticles.execute();

				oebrc_aBonLivraison.initTree();
				oebrc_aBonRetour.initTree();

				oebrc_disableEnlever(true,false);
				document.getElementById("oebrc-bConsultSerieLigne").disabled = true;
			}
		}

	} catch (e) {
  	recup_erreur(e);
	}
}


function oebrc_demandeEnregistrement() {
  try {

		if (oebrc_modified) {
			if (window.confirm("Voulez-vous enregistrer les modifications apport\u00E9es au retour ?")) {
				oebrc_enregistrerBon(false);
			}
		}

	} catch (e) {
  	recup_erreur(e);
	}
}


function oebrc_setModified(m) {
  try {

  	oebrc_modified = m && !gReadOnly;

		if (oebrc_modified) {
			document.getElementById('oebrc-tabBon').setAttribute('image', 'chrome://opensi/content/design/icones/modified.png');
			document.getElementById('oebrc-bValiderBR').disabled = true;
			document.getElementById('oebrc-bVisualiser').disabled = (oebrc_etatBon!='E');
		}
		else {
			document.getElementById('oebrc-tabBon').setAttribute('image', gReadOnly?'chrome://opensi/content/design/icones/readonly.png':null);
			document.getElementById('oebrc-bValiderBR').disabled = (oebrc_etatBon=='E');
			document.getElementById('oebrc-bVisualiser').disabled = false;
		}

	} catch (e) {
  	recup_erreur(e);
	}
}


function oebrc_visualiserBon() {
  try {

		if (oebrc_aBonRetour.nbLignes()<=0) {
			showWarning("Le retour ne contient aucune ligne !");
		}
		else {
			document.getElementById("bRetourBonRetour").collapsed = false;
			document.getElementById("oebrc-deckBonRetour").selectedIndex = 1;

			var qLangueDefaut = new QueryHttp("Facturation/Commun/getLangueDefaut.tmpl");
			qLangueDefaut.setParam("Type_Doc", "RC");
			qLangueDefaut.setParam("Doc_Id", retourId);
			var result = qLangueDefaut.execute();
			oebrc_langueDefaut = result.responseXML.documentElement.getAttribute("Langue_Id");
			oebrc_aLangues.setParam("Selection", oebrc_langueDefaut);
			oebrc_aLangues.initTree(oebrc_initLangue);
		}
	} catch (e) {
    recup_erreur(e);
  }
}


function oebrc_initLangue() {
	try {
		document.getElementById('oebrc-langueDefaut').value = oebrc_langueDefaut;
		oebrc_editerBon();
	} catch (e) {
		recup_erreur(e);
	}
}


function oebrc_editerBon() {
	try {
		var langue = document.getElementById('oebrc-langueDefaut').value;

		var oebrc_qGenPdf = new QueryHttp("Facturation/Affaires/pdfRetourClient.tmpl");
		oebrc_qGenPdf.setParam('Bon_Id', retourId);
	  oebrc_qGenPdf.setParam('Langue', langue);
		var result = oebrc_qGenPdf.execute();
		var page = getDirPdf() + result.responseXML.documentElement.getAttribute('fichier');

		document.getElementById('oebrc-pdfBonRetour').setAttribute("src", page);
	} catch (e) {
		recup_erreur(e);
	}
}


function oebrc_validerBon() {
  try {

		var typeRetour = document.getElementById('oebrc-typeRetour').value;

		if (oebrc_aBonRetour.nbLignes()<=0) {
			showWarning("Le retour ne contient aucune ligne !");
		}
		else if (isEmpty(typeRetour) || document.getElementById('oebrc-typeRetour').selectedIndex==-1) {
			showWarning("Veuillez choisir un type de retour");
		}
		else {
			var isChecked = true;
			if (oebrc_actSuiviSerie) {
				var qCheck = new QueryHttp("Facturation/Retours_Clients/checkNumSerieRC.tmpl");
				qCheck.setParam("Retour_Id", retourId);
				var result = qCheck.execute();
				var errors = new Errors(result);
				if (errors.hasNext()) {
					isChecked = false;
					errors.show();
				}
			}

			if (isChecked && window.confirm("Confirmez-vous la validation du retour ?\n(Attention le retour valid\u00E9 ne pourra plus \u00EAtre modifi\u00E9 !)")) {
				var qValid = new QueryHttp("Facturation/Affaires/validRetourClient.tmpl");
				qValid.setParam('Retour_Id', retourId);
				qValid.execute();

				oebrc_chargerBon();
			}
		}

	} catch (e) {
    recup_erreur(e);
  }
}

function oebrc_validerReception() {
  try {

		if (window.confirm("Confirmez-vous la validation de la r\u00E9ception ?")) {
			var qValiderReception = new QueryHttp("Facturation/Affaires/receiveRetourClient.tmpl");
			qValiderReception.setParam('Retour_Id', retourId);
			qValiderReception.execute();

			oebrc_chargerBon();

			var typeRetour = document.getElementById('oebrc-typeRetour').value;

			if (typeRetour=="R") {
				var qCheck = new QueryHttp("Facturation/Affaires/checkAvoirRetourPossible.tmpl");
				qCheck.setParam('Retour_Id', retourId);

				var result = qCheck.execute();

				var possible = result.responseXML.documentElement.getAttribute("Possible")=="true";

				if (possible && window.confirm("Voulez-vous cr\u00E9er un avoir pour ce retour ?")) {

					var qTrans = new QueryHttp("Facturation/Affaires/transformRetourAvoir.tmpl");
					qTrans.setParam('Retour_Id', retourId);

					result = qTrans.execute();

					var errors = new Errors(result);
					if (errors.hasNext()) {
						errors.show();
					}
					else {
						avoirId = result.responseXML.documentElement.getAttribute("Avoir_Id");
						oea_chargerAvoir();
						document.getElementById('deck').selectedIndex = 6;
					}
				}
			}
		}

	} catch (e) {
    recup_erreur(e);
  }
}


function oebrc_annulerBon() {
  try {

		if (window.confirm("Confirmez-vous l'annulation du retour ?")) {
			var qCancel = new QueryHttp("Facturation/Affaires/cancelRetourClient.tmpl");
			qCancel.setParam('Retour_Id', retourId);
			qCancel.execute();

			showMessage("Le retour a \u00E9t\u00E9 annul\u00E9 !");

			oebrc_chargerBon();
		}

	} catch (e) {
    recup_erreur(e);
  }
}


function oebrc_rechercherAdrLiv() {
  try {

  	oebrc_currentCodePaysLiv = document.getElementById('oebrc-codePaysLiv').value;

		var url = "chrome://opensi/content/facturation/user/commun/popup-choixAdresse.xul";
    window.openDialog(url,'','chrome,modal,centerscreen', oebrc_reporterAdrLiv, oebrc_clientId, gReadOnly);

	} catch (e) {
  	recup_erreur(e);
  }
}


function oebrc_reporterAdrLiv(nom, adr1, adr2, adr3, cp, ville, pays, code_pays, contact_fact, contact_liv, contact_envoi, contact_devis, adresseId) {
  try {

  	var qGet = new QueryHttp("Facturation/Affaires/getInfosCommandeClient.tmpl");
		qGet.setParam("Commande_Id", commandeId);
		var result = qGet.execute();

	  var assujettiTVA = result.responseXML.documentElement.getAttribute("Assujetti_TVA")=="true";

  	if (oebrc_currentCodePaysLiv!=code_pays && !assujettiTVA) {
  		showWarning("L'adresse choisie doit \u00EAtre dans le m\u00EAme pays que le pays de livraison actuel !");
  	}
		else {
			document.getElementById('oebrc-denominationLiv').value = nom;
			document.getElementById('oebrc-adresse1Liv').value = adr1;
			document.getElementById('oebrc-adresse2Liv').value = adr2;
			document.getElementById('oebrc-adresse3Liv').value = adr3;
			document.getElementById('oebrc-codePostalLiv').value = cp;
			document.getElementById('oebrc-villeLiv').value = ville;
		  document.getElementById('oebrc-codePaysLiv').value = code_pays;

			if (!isEmpty(contact_liv)) {
				var qLoad = new QueryHttp("Facturation/Clients/loadContactClient.tmpl");
		  	qLoad.setParam("Contact_Id", contact_liv);
		  	var result = qLoad.execute();
		  	var contenu = result.responseXML.documentElement;
		  	oebrc_reporterInterLiv(contenu.getAttribute("Civilite"),contenu.getAttribute("Nom"),contenu.getAttribute("Prenom"),contenu.getAttribute("Tel_1"),contenu.getAttribute("Tel_2"),contenu.getAttribute("Fax"),contenu.getAttribute("Email"));
		  }
			else {
				oebrc_setModified(true);
		  }
  	}

	} catch (e) {
  	recup_erreur(e);
  }
}


function oebrc_rechercherInterlocuteurLiv() {
  try {

		var url = "chrome://opensi/content/facturation/user/commun/popup-choixInter.xul";
    window.openDialog(url,'','chrome,modal,centerscreen', oebrc_reporterInterLiv, oebrc_clientId, gReadOnly);

	} catch (e) {
  	recup_erreur(e);
  }
}


function oebrc_reporterInterLiv(civ, nom, prenom, tel1, tel2, fax, email) {
  try {

		document.getElementById('oebrc-civInterLiv').value = civ;
		document.getElementById('oebrc-nomInterLiv').value = nom;
		document.getElementById('oebrc-prenomInterLiv').value = prenom;
		document.getElementById('oebrc-telInter1Liv').value = tel1;
		document.getElementById('oebrc-telInter2Liv').value = tel2;
		document.getElementById('oebrc-faxInterLiv').value = fax;
		document.getElementById('oebrc-emailInterLiv').value = email;

		oebrc_setModified(true);

	} catch (e) {
  	recup_erreur(e);
  }
}

function oebrc_choisirMentions() {
  try {

  	var ok = true;

  	if (oebrc_mode=="C") {
			ok = oebrc_enregistrerBon(true);
		}

		if (ok) {
			var url = "chrome://opensi/content/facturation/user/commun/popup-mentionsDocument.xul";
	    window.openDialog(url,'','chrome,modal,centerscreen', "RC", retourId, gReadOnly);
		}

	} catch (e) {
  	recup_erreur(e);
  }
}


function oebrc_initVersion() {
	try {

		oebrc_aVersion.setParam("Retour_Id", retourId);
		oebrc_aVersion.initTree();

	} catch (e) {
		recup_erreur(e);
	}
}


function oebrc_selectionLigneRC() {
	try {

	 	oebrc_reporterQteSortie();
	 	oebrc_disableEnlever(false,true);
	 	oebrc_disableAjouter(true,false);

	 	if (oebrc_aBonRetour.isSelected()) {
			var articleId = oebrc_aBonRetour.getSelectedCellText('oebrc-colArticleIdLiv');
			document.getElementById("oebrc-bConsultSerieLigne").disabled = isEmpty(articleId);
		}

	} catch (e) {
		recup_erreur(e);
	}
}


function oebrc_checkNumSerieLigne(ligneId, isSuiviSerie, quantite) {
	try {

		if (oebrc_actSuiviSerie) {
			var qNbSerie = new QueryHttp("Facturation/Retours_Clients/getNbNumSerieLigneRC.tmpl");
			qNbSerie.setParam("Ligne_Id", ligneId);
			var resNS = qNbSerie.execute();
			var nb = parseIntBis(resNS.responseXML.documentElement.getAttribute("Nombre"));
			if ((isSuiviSerie && nb!=quantite) || nb>quantite) {
				var url = "chrome://opensi/content/facturation/user/commun/popup-numSerie.xul";
		    window.openDialog(url,'','chrome,modal,centerscreen', "S", "RCA", ligneId);
			}
		}

	} catch (e) {
		recup_erreur(e);
	}
}


function oebrc_consulterNumSerie() {
	try {

		if (oebrc_aBonRetour.isSelected()) {
			var ligneId = oebrc_aBonRetour.getSelectedCellText('oebrc-colLigneIdLiv');
			var mode = (oebrc_etatBon=="A" || oebrc_etatBon=="V" || gReadOnly?"C":"S");
			var forfait = oebrc_aBonRetour.getSelectedCellText('oebrc-colTypeArticleLiv')=="F";
			var url = "chrome://opensi/content/facturation/user/commun/"+ (forfait?"popup-numSerieComposant.xul":"popup-numSerie.xul");
    	window.openDialog(url,'','chrome,modal,centerscreen', mode, "RCA", ligneId);
		}

	} catch (e) {
		recup_erreur(e);
	}
}


function oebrc_envoyer() {
	try {

		var langue = document.getElementById('oebrc-langueDefaut').value;

		var url = "chrome://opensi/content/popup/popup-envoyerMail.xul";
		window.openDialog(url,'','chrome,modal,centerscreen', "RC", retourId, langue);

	}	catch (e) {
    recup_erreur(e);
  }
}


function oebrc_importLignes() {
  try {

	  var url = "chrome://opensi/content/facturation/user/affaires/popup-importerLignesRC.xul";
	  window.openDialog(url,'','chrome,modal,centerscreen', oebrc_retourImportLignes, retourId);

  } catch (e) {
    recup_erreur(e);
  }
}


function oebrc_retourImportLignes() {
	try {

		oebrc_aBonLivraison.initTree();
		oebrc_aBonRetour.initTree();
		oebrc_disableAjouter(true,false);
		oebrc_disableEnlever(true,false);

	} catch (e) {
	  recup_erreur(e);
	}
}
