/**********************************************************************************************/
/* OpenSi : Logiciel SaaS de gestion commerciale et comptabilit spcialis dans l'e-commerce */
/* Copyright (c) - Tous droits rservs - SAS Speedinfo Evolution                             */
/**********************************************************************************************/


jsLoader.loadSubScript("chrome://opensi/content/libs/arbres.js");
jsLoader.loadSubScript("chrome://opensi/content/libs/query.js");


var arbre = new Arbre("Facturation/Commerciaux/liste_commerciaux_inscrits.tmpl", "liste_commerciaux");
var est_admin = false;


function init() {
  try {

  	var queryCommercial = new QueryHttp("Facturation/Commerciaux/typeUser.tmpl");
  	queryCommercial.execute(initCommercial);

	} catch (e) {
    recup_erreur(e);
  }
}


function initCommercial(result) {
	try {

		est_admin = (result.responseXML.documentElement.getAttribute("admin")=="true");
		var commercial_id = result.responseXML.documentElement.getAttribute("commercial");

		document.getElementById('barre_actions').collapsed = !est_admin;
		document.getElementById('liste_commerciaux').collapsed = !est_admin;

		if (est_admin) {
  		arbre.initTree();
		}
		else if (commercial_id!="") {
			var params = "&NewCommercial=false&Commercial_Id="+ commercial_id +"&isAdmin=false";
    	urlCommerciaux = "chrome://opensi/content/facturation/user/commerciaux/gestion_commerciaux.xul?"+ cookie() + params;
			window.location = urlCommerciaux;
		}
		else {
			retourMenuPrincipal();
			showWarning("Vous ne disposez pas des droits d'acc\u00E8s \u00E0 ce menu.\u000D Veuillez prendre contact avec votre administrateur en cas de n\u00E9cessit\u00E9.");
		}

	}	catch(e) {
    recup_erreur(e);
	}
}


function pressOnTree() {
	try {

		if (arbre.isSelected()) {
			var actif = (arbre.getSelectedCellText('ColActif')=="1");
			document.getElementById('bModifier').disabled = false;
			document.getElementById('bSupprimer').disabled = !actif;
			document.getElementById('bReactiver').disabled = actif;
		}

	} catch (e) {
    recup_erreur(e);
  }
}


function modifierCommercial() {
	try {

		if (arbre.isSelected()) {
			var commercial_id = arbre.getSelectedCellText('ColCommercial_Id');
			var actif = arbre.getSelectedCellText('ColActif');
			var params = "&NewCommercial=false&Commercial_Id="+ commercial_id +"&isAdmin="+ est_admin +"&Actif="+actif;

    	window.location = "chrome://opensi/content/facturation/user/commerciaux/gestion_commerciaux.xul?"+ cookie() + params;
		}

	} catch (e) {
    recup_erreur(e);
  }
}


function nouveauCommercial() {
	try {

		var params = "&NewCommercial=true&isAdmin="+ est_admin +"&Actif=1";
		window.location = "chrome://opensi/content/facturation/user/commerciaux/gestion_commerciaux.xul?"+ cookie() + params;

	} catch (e) {
    recup_erreur(e);
  }
}


function desactiverCommercial() {
	try {

		if (arbre.isSelected()) {
			if (confirm("Confirmez-vous la d\u00E9sactivation de ce commercial ?")) {
				var queryDesactiverCom = new QueryHttp("Facturation/Commerciaux/suppression_commercial.tmpl");
      	queryDesactiverCom.setParam("Commercial_Id", arbre.getSelectedCellText('ColCommercial_Id'));
      	queryDesactiverCom.execute();
				arbre.initTree();
			}
			document.getElementById('bModifier').disabled = true;
			document.getElementById('bSupprimer').disabled = true;
		}

	} catch(e) {
    recup_erreur(e);
  }
}


function reactiverCommercial() {
	try {

		if (arbre.isSelected()) {
			if (confirm("Confirmez-vous la r\u00E9activation de ce commercial ?")) {
				var queryReactiverCom = new QueryHttp("Facturation/Commerciaux/reactivation_commercial.tmpl");
      	queryReactiverCom.setParam("Commercial_Id", arbre.getSelectedCellText('ColCommercial_Id'));
      	queryReactiverCom.execute();
				arbre.initTree();
			}
			document.getElementById('bModifier').disabled = true;
			document.getElementById('bReactiver').disabled = true;
		}

	} catch(e) {
    recup_erreur(e);
  }
}


function retourMenuPrincipal() {
	try {

    window.location = "chrome://opensi/content/facturation/user/menu_principal.xul?"+ cookie();

	} catch (e) {
    recup_erreur(e);
  }
}

